/***************************************************************************
                          fpixmapwidget.cpp  -  description
                             -------------------
 Copyright (c) 2002 Tero Favorin (info@favorin.com)
 This program is distributed under the terms of the BSD License.
 See file COPYING for license details.
 ***************************************************************************/
#include <qpainter.h>
#include <qtooltip.h>

#include "fpixmapwidget.h"

FPixmapWidget::FPixmapWidget(const QPixmap &pixmap, QWidget *parent, const char *name, WFlags f ) : QFrame(parent,name,f) {
  pixmargin=2;
  setPixmap(pixmap);
}
FPixmapWidget::FPixmapWidget(const QPixmap &pixmap, const QString &tooltip, QWidget *parent, const char *name, WFlags f) : QFrame(parent,name,f) {
  pixmargin=2;
  setPixmap(pixmap);
  QToolTip::add(this,tooltip);
}  
FPixmapWidget::~FPixmapWidget(){
}
void FPixmapWidget::drawContents(QPainter *p) {
  if (!pix.isNull())
    p->drawPixmap((width()-pix.width())/2,(height()-pix.height())/2,pix);
}
void FPixmapWidget::setPixmap(const QPixmap &pixmap) {
  pix=pixmap;
  if (!pix.isNull())
    setMinimumSize(pix.width()+pixmargin,pix.height()+pixmargin);
  update();
}
const QPixmap FPixmapWidget::pixmap() const {
  return pix;
}
void FPixmapWidget::setMargin(int m) {
  pixmargin=m;
  if (!pix.isNull())
    setMinimumSize(pix.width()+pixmargin,pix.height()+pixmargin);  
}
