/***************************************************************************
                          fpixmapwidget.h  -  description
                             -------------------
 Copyright (c) 2002 Tero Favorin (info@favorin.com)
 This program is distributed under the terms of the BSD License.
 See file COPYING for license details.
 ***************************************************************************/



#ifndef FPIXMAPWIDGET_H
#define FPIXMAPWIDGET_H

#include <qwidget.h>
#include <qframe.h>
#include <qpixmap.h>

/**
  *@author Tero Favorin
  */

class FPixmapWidget : public QFrame  {
   Q_OBJECT
public: 
	FPixmapWidget(const QPixmap &pixmap, QWidget *parent=0, const char *name=0, WFlags f=0);
 	FPixmapWidget(const QPixmap &pixmap, const QString &tooltip, QWidget *parent=0, const char *name=0, WFlags f=0);
  ~FPixmapWidget();
  void setPixmap(const QPixmap &pixmap);
  const QPixmap pixmap() const;
  virtual void setMargin(int margin);
  int margin() const {return pixmargin;}  
protected:
	virtual void drawContents ( QPainter *p );
private:
  QPixmap pix;
  int pixmargin; 
};

#endif
