/***************************************************************************
                          kexdatasource.cpp  -  description
                             -------------------
    begin                : Mon Mar 4 2002
    copyright            : (C) 2002 by Tero Favorin
    email                : tero@favorin.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <math.h>
#include <qfile.h>
#include <qdom.h>
#include <qbitmap.h>
#include <qpixmapcache.h>

#include <kapplication.h>
#include <kstandarddirs.h>
#include <kiconloader.h>
#include <klocale.h>
#include <dcopclient.h>

#include "kexdataengine.h"

KExDataEngine::KExDataEngine(QWidget *w) : QObject(0),DCOPObject("DataEngine") {
  sources.setAutoDelete(true);
  parent=w;
	precision=5;
	highPrecision=11;

  KApplication::kApplication()->dcopClient()->setDefaultObject( objId() );

	defaultFlag=QPixmap(21,14);
	defaultFlag.fill(white);
	defaultFlag.setMask(defaultFlag.createHeuristicMask());	// Create transparent Pixmap

	// Currency names
	names.insert("ADP",i18n("Andorran Peseta"));
  names.insert("AED",i18n("United Arab Emirates Dirham"));
  names.insert("AFN",i18n("Afganistan Afgani"));
  names.insert("ALL",i18n("Albanian Lek"));
  names.insert("ANG",i18n("Neth. Antilles Guilders"));
  names.insert("AMD",i18n("Armenia Dram"));
  names.insert("AOA",i18n("Angolan Kwanza"));
  names.insert("ARS",i18n("Argentine Pesos"));
	names.insert("ATS",i18n("Austrian Schillings"));
	names.insert("AUD",i18n("Australian Dollars"));
	names.insert("AWG",i18n("Aruban Guilder"));
	names.insert("AZM",i18n("Azerbaijan Manat"));
  names.insert("BAM",i18n("Bosnia and Herzegovina Conv. Marka"));
	names.insert("BBD",i18n("Barbados Dollars"));
  names.insert("BDT",i18n("Bangladesh Taka"));
	names.insert("BEF",i18n("Belgian Francs"));
	names.insert("BGL",i18n("Bulgarian Lev"));
	names.insert("BHD",i18n("Bahraini Dinars"));
  names.insert("BIF",i18n("Burundi Franc"));
	names.insert("BMD",i18n("Bermudian Dollars"));
  names.insert("BND",i18n("Brunei Dollar"));
  names.insert("BOB",i18n("Bolivian Boliviano"));
  names.insert("BRL",i18n("Brazilian Reals"));
	names.insert("BSD",i18n("Bahamian Dollars"));
  names.insert("BTN",i18n("Bhutan Ngultrum"));
  names.insert("BWP",i18n("Botswana Pula"));
  names.insert("BYR",i18n("Belarus Ruble"));
  names.insert("BZD",i18n("Belize Dollar"));
  names.insert("CAD",i18n("Canadian Dollars"));
  names.insert("CDF",i18n("Dem. Rep. Congo Franc"));
  names.insert("CHF",i18n("Swiss Francs"));
	names.insert("GNF",i18n("Guinea Franc"));
	names.insert("CNY",i18n("Chinese Renminbi"));
	names.insert("CLP",i18n("Chilean Pesos"));
	names.insert("CZK",i18n("Czech Koruna"));
	names.insert("CRC",i18n("Costa Rican Colon"));  
	names.insert("COP",i18n("Colombian Pesos"));
	names.insert("CUP",i18n("Cuban Peso"));
  names.insert("CVE",i18n("Cape Verde Escudo"));    
	names.insert("CYP",i18n("Cypriot Pound"));
	names.insert("KYD",i18n("Cayman Island Dollar"));  
	names.insert("DEM",i18n("German Marks"));
  names.insert("DJF",i18n("Djibouti Franc"));  
	names.insert("DKK",i18n("Danish Kroner"));
  names.insert("DOP",i18n("Dominican Republic Pesos"));  
	names.insert("DZD",i18n("Algerian Dinar"));
	names.insert("ECS",i18n("Ecuadoran Sucre"));
  names.insert("EEK",i18n("Estonian Kroon"));  
	names.insert("EGP",i18n("Egyptian Pounds"));
  names.insert("ERN",i18n("Eritrean Nakfa"));
  names.insert("ETB",i18n("Ethiopian Birr"));    
	names.insert("ESP",i18n("Spanish Pesetas"));
	names.insert("EUR",i18n("European Euros"));
	names.insert("FIM",i18n("Finnish Markka"));
	names.insert("FJD",i18n("Fijian Dollars"));
	names.insert("FRF",i18n("French Francs"));
	names.insert("GBP",i18n("British Pounds"));
  names.insert("GEL",i18n("Georgia Lari"));
  names.insert("GHC",i18n("Ghanan New Cedis"));
  names.insert("GMD",i18n("Gambian Dalasi"));
  names.insert("GRD",i18n("Greek Drachmas"));
  names.insert("GTQ",i18n("Guatemala Quetzal"));
  names.insert("GYD",i18n("Guyana Dollar"));
	names.insert("HNL",i18n("Honduran Lempiras"));
	names.insert("HKD",i18n("Hong Kong Dollars"));
  names.insert("HRK",i18n("Croatian Kuna"));
  names.insert("HTG",i18n("Haiti Gourde"));
  names.insert("HUF",i18n("Hungarian Forint"));
	names.insert("IDR",i18n("Indonesian Rupiah"));
	names.insert("IEP",i18n("Irish Punt"));
	names.insert("ILS",i18n("Israeli New Shekels"));
	names.insert("INR",i18n("Indian Rupees"));
	names.insert("ISK",i18n("Icelandic Krona"));
	names.insert("ITL",i18n("Italian Lira"));
  names.insert("IQD",i18n("Iraqi Dinar"));
  names.insert("IRR",i18n("Iranian Rial"));  
  names.insert("JMD",i18n("Jamaican Dollars"));
	names.insert("JOD",i18n("Jordanian Dinar"));
	names.insert("JPY",i18n("Japanese Yen"));
  names.insert("KES",i18n("Kenyan Shilling"));
  names.insert("KGS",i18n("Kyrgyzstan Som"));
  names.insert("KHR",i18n("Cambodia Riel"));
  names.insert("KMF",i18n("Comoros Franc"));
  names.insert("KPW",i18n("North Korean Won"));
  names.insert("KRW",i18n("South Korean Won"));
	names.insert("KZT",i18n("Kazakhstan Tenge"));
	names.insert("KWD",i18n("Kuwaiti Dinar"));
  names.insert("LAK",i18n("Laos New Kip"));
  names.insert("LBP",i18n("Lebanese Pound"));
	names.insert("LKR",i18n("Sri Lankan Rupees"));
  names.insert("LRD",i18n("Liberian Dollar"));
  names.insert("LSL",i18n("Lesotho Loti"));
  names.insert("LTL",i18n("Lithuanian Litas"));
  names.insert("LVL",i18n("Latvian Lat"));  
  names.insert("LUF",i18n("Luxembourg Francs"));
  names.insert("LYD",i18n("Libyan Dinar"));  
	names.insert("MAD",i18n("Moroccan Dirham"));
	names.insert("MDL",i18n("Moldova Lei"));
  names.insert("MGF",i18n("Madagascar Franc"));
  names.insert("MKD",i18n("Macedonia Denar"));
  names.insert("MMK",i18n("Myanmar Kyat"));
  names.insert("MNT",i18n("Mongolia Tugrik"));
  names.insert("MOP",i18n("Macau Pataca"));
  names.insert("MRO",i18n("Mauritania Ouguiya"));
  names.insert("MTL",i18n("Maltese Lira"));
  names.insert("MUR",i18n("Mauritius Rupee"));
  names.insert("MYR",i18n("Malaysian Ringgit"));
  names.insert("MVR",i18n("Maldives Rufiyaa"));
  names.insert("MWK",i18n("Malawi Kwacha"));
  names.insert("MXN",i18n("Mexican Pesos"));
  names.insert("MZM",i18n("Mozambique Metical"));
  names.insert("NAD",i18n("Namibia Dollar"));
  names.insert("NGN",i18n("Nigeria Naira"));
  names.insert("NIC",i18n("Nicaraguan Cordoba"));
  names.insert("NLG",i18n("Dutch Guilders"));
	names.insert("NOK",i18n("Norwegian Kroner"));
  names.insert("NPR",i18n("Nepal Rupee"));
  names.insert("NZD",i18n("New Zealand Dollars"));
  names.insert("OMR",i18n("Omani Rial"));
  names.insert("PAB",i18n("Panamaan Balboas"));
	names.insert("PEN",i18n("Peruvian New Soles"));
	names.insert("PGK",i18n("Papua New Guinean Kina"));
  names.insert("PHP",i18n("Philippines Pesos"));
	names.insert("PKR",i18n("Pakistani Rupees"));
	names.insert("PLN",i18n("Polish Zloty"));
	names.insert("PTE",i18n("Portuguese Escudo"));
  names.insert("PYG",i18n("Paraguay Guarani"));
  names.insert("QAR",i18n("Qatari Riyal"));
  names.insert("ROL",i18n("Romanian Leu"));
	names.insert("RUR",i18n("Russian Rubles"));
  names.insert("RWF",i18n("Rwanda Franc"));
  names.insert("SAR",i18n("Saudi Arabian Riyal"));
  names.insert("SBD",i18n("Solomon Island Dollars"));
  names.insert("SCR",i18n("Seychelles Rupee"));
  names.insert("SDD",i18n("Sudanese Dinars"));
  names.insert("SEK",i18n("Swedish Krona"));
	names.insert("SGD",i18n("Singapore Dollars"));
  names.insert("SIT",i18n("Slovenia Tolar"));
  names.insert("SKK",i18n("Slovakian Koruna"));
  names.insert("SLL",i18n("Sierra Leone Leone"));
  names.insert("SOS",i18n("Somali Schilling"));
	names.insert("SRG",i18n("Surinam Guilder"));
	names.insert("STD",i18n("Sao Tome Dobra"));
	names.insert("SVC",i18n("El Salvador Colon"));
	names.insert("SYP",i18n("Syrian Pound"));  
  names.insert("SZL",i18n("Swaziland Lilangeni"));
  names.insert("THB",i18n("Thai Baht"));
  names.insert("TJS",i18n("Tajikistan Somoni"));
  names.insert("TND",i18n("Tunisian Dinars"));
  names.insert("TMM",i18n("Turkmenistan Manat"));
  names.insert("TRL",i18n("Turkish Lira"));
	names.insert("TTD",i18n("Trinidad and Tobago Dollars"));
	names.insert("TWD",i18n("Taiwanese Dollars"));
  names.insert("TZS",i18n("Tanzanian Shilling"));
  names.insert("UAH",i18n("Ukrainian Hryvna"));
  names.insert("UGX",i18n("Ugandan Shilling"));
  names.insert("USD",i18n("U.S. Dollars"));
  names.insert("UYU",i18n("Uruguayan Pesos"));
  names.insert("UZS",i18n("Uzbekistan Sum"));  
	names.insert("VEB",i18n("Venezuelan Bolivars"));
  names.insert("VND",i18n("Vietnam Dong"));
  names.insert("VUV",i18n("Vanuatu Vatu"));  
	names.insert("YER",i18n("Yemeni Rial"));
  names.insert("YUM",i18n("Yugoslav Dinar"));
  names.insert("XAF",i18n("French-African Francs"));
	names.insert("XCD",i18n("East Caribbean Dollars"));
	names.insert("XPF",i18n("French-Pacific Francs"));
	names.insert("ZAR",i18n("South African Rand"));
	names.insert("ZMK",i18n("Zambian Kwacha"));
  names.insert("ZWD",i18n("Zimbabwe Dollar"));  

	// List of native currencies that have switched to Euro.
	eurolist.append("ATS");
	eurolist.append("BEF");
	eurolist.append("DEM");
	eurolist.append("ESP");
	eurolist.append("FIM");
	eurolist.append("FRF");
	eurolist.append("GRD");
	eurolist.append("IEP");
	eurolist.append("ITL");
	eurolist.append("LUF");
	eurolist.append("NLG");
	eurolist.append("PTE");
	// Euro conversion rates
	data.insert(getKey("ATS","EUR"),KExData(13.7603,QDate(1998,12,31),Conversion));
	data.insert(getKey("BEF","EUR"),KExData(40.3399,QDate(1998,12,31),Conversion));
	data.insert(getKey("DEM","EUR"),KExData(1.95583,QDate(1998,12,31),Conversion));
	data.insert(getKey("ESP","EUR"),KExData(166.386,QDate(1998,12,31),Conversion));
	data.insert(getKey("FIM","EUR"),KExData(5.94573,QDate(1998,12,31),Conversion));
	data.insert(getKey("FRF","EUR"),KExData(6.55957,QDate(1998,12,31),Conversion));
	data.insert(getKey("GRD","EUR"),KExData(340.750,QDate(2001,1,1),Conversion));
	data.insert(getKey("IEP","EUR"),KExData(0.787564,QDate(1998,12,31),Conversion));
	data.insert(getKey("ITL","EUR"),KExData(1936.27,QDate(1998,12,31),Conversion));
	data.insert(getKey("LUF","EUR"),KExData(40.3399,QDate(1998,12,31),Conversion));
	data.insert(getKey("NLG","EUR"),KExData(2.20371,QDate(1998,12,31),Conversion));
	data.insert(getKey("PTE","EUR"),KExData(200.482,QDate(1998,12,31),Conversion));

	addCurrency("EUR");
	readData();	
}
KExDataEngine::~KExDataEngine(){        	
}
const QString KExDataEngine::getKey(const QString &target, const QString &base) const {
	return target+"/"+base;
}
const QString KExDataEngine::getTarget(const QString &key) const {
   int slash;
   slash=key.find('/');
   Q_ASSERT(slash>0);
   return key.left(slash);
}
bool KExDataEngine::addCurrency(const QString &code) {
  if (names.contains(code)) {
  	if (!eurolist.contains(code) && !list.contains(code)) {
	  	list.append(code);
		}
  } else {
    //qDebug("Unknown currency: \""+code+"\"");
		return false;
	}
	return true;
}
void KExDataEngine::removeRate(const QString &key) {
  ExData::ConstIterator it;
  QString target=getTarget(key);
  bool found=false;
  
  data.remove(key);  
  for( it = data.begin(); it != data.end(); ++it ) {
    if (getTarget(it.key())==target) {
      found=true;
    }
  }
  if (!found)
    list.remove(target);  
}
void KExDataEngine::addRate(const QString &target, const QString &base, Rate rate, const QDate &date, Confidence confidence) {
	if (!eurolist.contains(target) && !eurolist.contains(base) && names.contains(target) && names.contains(base)) {
		KExData d(rate,date,confidence);
		data.insert(getKey(target,base),d);
	}
}
double KExDataEngine::convert(const QString &target, const QString &base, double amount) const {
	if (eurolist.contains(target) && eurolist.contains(base)) {
		ExData::ConstIterator it=data.find(getKey(target,"EUR")); // Convert via euro
		if (it!=data.end())
				return convert("EUR",base,round((*it).rate,precision)*amount);
	}
	return getRate(target,base).rate*amount;
}
const KExData KExDataEngine::getRate(const QString &target, const QString &base) const {
	if (target==base)
		return KExData(1,QDate::currentDate(),Conversion);
	ExData::ConstIterator it=data.find(getKey(target,base));
	if (it!=data.end()) // Try to find exact match
		return *it;
	else {
		it=data.find(getKey(base,target)); // Try to find inversed match
		if (it!=data.end()) {
			if ((*it).rate>0)
				return KExData(round(1/(*it).rate,precision),(*it).date,(*it).confidence);
			else
				return KExData(0,(*it).date,None);
		}
		else {
			KExData d;
			if (eurolist.contains(target) && eurolist.contains(base)) {
				it=data.find(getKey(target,"EUR"));
				d=*it;
				it=data.find(getKey(base,"EUR"));
				d.rate=round(d.rate/(*it).rate,precision);
				if ((*it).date>d.date)
					d.date=(*it).date;
				d.confidence=CrossConversion;
				return d;
			}
			KExData t=toUSD(target);
			KExData b=toUSD(base);
			if (b.rate>0) {
				d=KExData(t.rate/b.rate,t.date<b.date ? t.date : b.date,Calculated);
        if (t.confidence==Unreliable || b.confidence==Unreliable)
          d.confidence=Unreliable;
      } else
				d=KExData(0,b.date,None);
			return d;
		}
	}
}
KExData KExDataEngine::toUSD(QString code) const {
	ExData::ConstIterator it;
	KExData d;
	if (code!="USD") {
		if (eurolist.contains(code)) { // Convert national currency units of Euro first to EUR
			it=data.find(getKey(code,"EUR"));
			if (it!=data.end()) {
				d=*it;
				code="EUR";
			} else
				return KExData();
		}
		it=data.find(getKey(code,"USD")); // Get USD rate
		if (it!=data.end()) {
			if (d.rate==0)
				d=*it;
			else {
				Rate r=d.rate;
				d=*it;
				d.rate=r*d.rate;
			}
		} else
			return KExData();
	} else
		d=KExData(1,QDate::currentDate(),Reliable);
	d.rate=round(d.rate,precision);
	return d;
}
const QString KExDataEngine::getCurrencyName(const QString &code) const {
	CurrencyNames::ConstIterator it=names.find(code);
	if (it!=names.end())
		return *it;
	else
		return code;
}
const QStringList KExDataEngine::getCurrencies(bool oldeuro) const {
	typedef QMap<QString,QString> NameMap;
	NameMap namemap;
	QStringList namelist,sortedlist;
  CurrencyNames::ConstIterator it;
	QStringList::ConstIterator it2;
	NameMap::ConstIterator it3;
	QStringList curlist(list);
	if (oldeuro)
		curlist+=eurolist;

  for( it = names.begin(); it != names.end(); ++it ) {
		if (curlist.contains(it.key())>0) {
	  	namemap.insert(it.data(),it.key());
			namelist.append(it.data());
		}
	}
	namelist.sort();
  for (  it2 = namelist.begin(); it2 != namelist.end(); ++it2 ) {
		 it3=namemap.find(*it2);
     sortedlist.append(*it3);
  }
	return sortedlist;
}
void KExDataEngine::storeData() const {
  ExData::ConstIterator it;
	QFile f( locateLocal("appdata", "rates.xml"));
	if ( f.open(IO_WriteOnly) ) {
    QTextStream t( &f );
		t << "<exchangerates>\n";
	  for( it = data.begin(); it != data.end(); ++it ) {
			if (!eurolist.contains(getTarget(it.key()))) {
				t << "  <rate>\n";
				t << "    <key>"+it.key()+"</key>\n";
				t << "    <rate>"+QString::number((*it).rate)+"</rate>\n";
				t << "    <date>"+QString::number((*it).date.year())+"-"+QString::number((*it).date.month())+"-"+QString::number((*it).date.day())+"</date>\n";
				t << "    <confidence>"+QString::number((*it).confidence)+"</confidence>\n";
				t << "  </rate>\n";
			}
		}
		t << "</exchangerates>\n";
    f.close();
  }
}

void KExDataEngine::readData() {
	QString key,file,errMsg;
	QDate date;
	Rate rate=0;
	int confidence=None, errLine, errCol;
  bool ok;

	file = locate("appdata", "rates.xml");
	if (file.isNull())
		return;
  QFile f( file );
  if ( !f.open( IO_ReadOnly ) )
      return;
  QDomDocument doc( "rates" );
  if ( !doc.setContent( &f, &errMsg, &errLine, &errCol ) ) {
      qDebug("Error reading rates.xml: %s (line: %i column: %i)",errMsg.latin1(),errLine,errCol);
      f.close();
      return;
  }
  f.close();
	addCurrency("USD");
  QDomElement docElem = doc.documentElement();
  QDomNode n = docElem.firstChild();
  while( !n.isNull() ) {
      QDomElement e = n.toElement();
      if( !e.isNull() ) {
				if (e.tagName()=="rate") {
				  QDomNode n2 = e.firstChild();
				  while( !n2.isNull() ) {
			      QDomElement e2 = n2.toElement();
				    if( !e2.isNull() ) {
							if (e2.tagName()=="key")
								key=e2.firstChild().toText().data();
							if (e2.tagName()=="rate")
								rate=e2.firstChild().toText().data().toDouble(&ok);
							if (e2.tagName()=="date")
								date=parseDate(e2.firstChild().toText().data(),'-');
							if (e2.tagName()=="confidence")
								confidence=e2.firstChild().toText().data().toInt(&ok);
						}
			      n2 = n2.nextSibling();
					}
					if (date.isValid() && confidence!=None) {
						if (addCurrency(key.left(key.find('/'))))
							data.insert(key,KExData(rate,date,(Confidence)confidence));
					}
				}
      }
      n = n.nextSibling();
  }
}
const QDate KExDataEngine::parseDate(const QString &str, const QChar &sep) {
	bool ok;
	QStringList::ConstIterator it;
	int y,m,d;
	QStringList l=QStringList::split(sep,str,true);
	if (l.count()==3) {
		it=l.at(0);
  	y=(*it).toInt(&ok);
		it=l.at(1);
  	m=(*it).toInt(&ok);
		it=l.at(2);
  	d=(*it).toInt(&ok);
		if (y>0 && m>0 && d>0) {
			return QDate(y,m,d);
		}
	}
	return QDate();
}

const QPixmap KExDataEngine::getFlag(const QString &code) {
	QPixmap flag;
  if ( !QPixmapCache::find("flag_"+code, flag) ) {
     if (flag.load(locate( "locale",
	 		 QString::fromLatin1( "l10n/%1/flag.png" ) .arg(code.left(2).lower()) ) ))
	     QPixmapCache::insert("flag_"+code, flag);
		 else {
       if (flag.load(locate( "data",
  	 		 QString::fromLatin1( "kexchange/icons/hicolor/16x16/actions/flag_%1.png" ) .arg(code.left(2).lower()) ) ))
		     QPixmapCache::insert("flag_"+code, flag);
  		 else {
				 flag=defaultFlag;
	       QPixmapCache::insert("flag_"+code, flag);
			 }
		 }
  }
	return flag;
}
const QPixmap KExDataEngine::getConfidenceIcon(int c) const {
  QString name;
  switch ((Confidence)c) {
    case None: return QPixmap(); break;
    case Conversion: name="conversion"; break;
    case Reliable: name="reliable"; break;
    case Calculated: name="calculated"; break;
    case CrossConversion: name="crossconversion"; break;
    case Unreliable: name="unreliable"; break;
  }
  return KGlobal::iconLoader()->loadIcon(name,KIcon::Small);
}
QString KExDataEngine::getCode(const QStringList &list, int pos) {
	if (pos>=0) {
		QStringList::ConstIterator it=list.at(pos);
		return *it;
	}
	return QString::null;
}
void KExDataEngine::refresh() {
  runningSource=-1;
  sourceReady();        
}
void KExDataEngine::sourceReady() {
  runningSource++;
  KExDataSource *s=sources.at(runningSource);
  if (s)
    s->refresh();
  else {
    clearOldRates();
    storeData();
    emit dataReady(true);
  }
}    
void KExDataEngine::addSource(KExDataSource *source) {
  sources.append(source);
  connect(source,SIGNAL(sourceReady()),this,SLOT(sourceReady()) );
}
KExDataSource* KExDataEngine::getSource() {
  return sources.at(0);
}
void KExDataEngine::emitStatus(int type, const QString &txt) {
  emit status(type,txt);
}
void KExDataEngine::clearOldRates() {
  ExData::Iterator it;
  QDate limit=QDate::currentDate();
  limit=limit.addDays(-7);
  for( it = data.begin(); it != data.end(); ++it ) {
    if ((*it).confidence!=Conversion && (*it).date<limit)
      removeRate(it.key());
  }
}
QString KExDataEngine::round(Rate r) const {
	int p=precision;
	if (round(r,precision,false)==0 && round(r,highPrecision,false)!=0)
		p=highPrecision;
	return KGlobal::locale()->formatNumber(r,p);
}
/**
	This routine originally by Josef Wolfsteiner from http://www.codeproject.com/cpp/floatutils.asp
*/
Rate KExDataEngine::round(Rate doValue, int nPrecision, bool upgrade) const {
				Rate result;
        static const Rate doBase = 10.0f;
        Rate doComplete5, doComplete5i;

        doComplete5 = doValue * pow(doBase, (Rate) (nPrecision + 1));

        if(doValue < 0.0f)
                doComplete5 -= 5.0f;
        else
                doComplete5 += 5.0f;

        doComplete5 /= doBase;
        modf(doComplete5, &doComplete5i);

				result=doComplete5i / pow(doBase, (Rate) nPrecision);
				if (result==0 && nPrecision<highPrecision && upgrade)
					result=round(doValue,highPrecision);
        return result;

}
QString KExDataEngine::getAllRates(const QString &base, bool unitToBase, bool showEuro) const {
  QString txt;
  QTextStream t(&txt,IO_WriteOnly);
  QStringList list=getCurrencies(showEuro);
	KExData r;
	t << i18n("Currency") << ";" << i18n("Code") << ";" << i18n("Exchange rate")+" (";
	if (unitToBase)
		t << i18n("unit")+"/"+base;
	else
		t << base+"/"+i18n("unit");
	t << ")\n";
	for ( QStringList::ConstIterator it = list.begin(); it != list.end(); ++it ) {
	  t << getCurrencyName(*it) << ";";
	  t << *it << ";";
		if (unitToBase)
			r=getRate(*it,base);
		else
			r=getRate(base,*it);
	  t << round(r.rate) << "\n";
  }
  return txt;
}  

