/***************************************************************************
                          kexdataretriever.h  -  description
                             -------------------
    begin                : Tue Mar 18 2003
    copyright            : (C) 2003 by Tero Favorin
    email                : tero@favorin.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KEXDATARETRIEVER_H
#define KEXDATARETRIEVER_H

#include <qobject.h>
#include <kio/job.h>

#include "kexdataengine.h"
/**
  *@author Tero Favorin
  */
class QTextStream;
    
class KExDataRetriever : public QObject {
  Q_OBJECT
public: 
	KExDataRetriever(const QString& name,KExDataSource *src);
	virtual ~KExDataRetriever();

  /** Initiate data transfer **/
	virtual void startTransfer()=0;
	/** Read data retrieved from the data source. */
	virtual int readData(QTextStream &s)=0;
  /** Name of this data retriever **/
  const QString& name() const {return _name;}
  
  static QString getText(QString txt);
signals:
  void retrieverReady(bool);
protected:
  /** Read data retrieved from the data source. */
	void transferData(KIO::TransferJob *j);
  bool addCurrency(const QString &code);
	void addRate(const QString &target, const QString &base, Rate rate, const QDate &date, Confidence confidence);
  
  KExDataEngine *engine;  
private slots:
	void slotResult( KIO::Job * );
	void slotData ( KIO::Job *, const QByteArray &);
	void slotMessage ( KIO::Job *, const QString & );
private:
  void clear();
  /** Data retriever name */
  QString _name;
	/** Data received from the data source */
	QByteArray *datain;
	/** Stream for writing to datain */
	QDataStream *streamin;    
};

#endif
