/***************************************************************************
                          kexdatasource.h  -  description
                             -------------------
    begin                : Tue Mar 18 2003
    copyright            : (C) 2003 by Tero Favorin
    email                : tero@favorin.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KEXDATASOURCE_H
#define KEXDATASOURCE_H

#include <qobject.h>
#include <qptrlist.h>

class KExDataEngine;
class KExDataRetriever;
class KURL;
/**
  *@author Tero Favorin
  */
typedef QPtrList<KExDataRetriever> DataRetrievers;

class KExDataSource : public QObject {
  Q_OBJECT
  friend class KExDataRetriever;  
public: 
	KExDataSource(KExDataEngine *eng);
	virtual ~KExDataSource();
  /** Refresh exchange rates from the data source.
  	Implementing class must create a KTransferJob then call transferData() and exit.
		After data transfer is finished, readData() will be called.
		Full sequence is refresh()->transferData()->readData()->storeData().
	*/
	void refresh();
  /** Data source source info  */
  virtual const QString source()=0;
	/** Data source source url  */  
	virtual const KURL sourceURL()=0;
	/** Data source source url  */   
	const QString sourceURLStr();  
	/** Data source copyright info */  
	virtual const QString copyright()=0;
signals:
  void sourceReady();
protected slots:
  void retrieverReady(bool);
protected:  
  KExDataEngine *engine;
  DataRetrievers retrievers;
private:
  int runningRetriever;  
};

#endif
