/***************************************************************************
                          kexpacificmain.cpp  -  description
                             -------------------
    begin                : Tue Mar 18 2003
    copyright            : (C) 2003 by Tero Favorin
    email                : tero@favorin.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kexpacificmain.h"

#define TAB_CHAR 9

KExPacificMain::KExPacificMain(const QString& name,KExDataSource *src) : KExDataRetriever(name,src) {
}
KExPacificMain::~KExPacificMain(){
}
void KExPacificMain::startTransfer() {
  QByteArray postData;
	QString *args=new QString("rd=7&f=tab&q=volume&y=daily&b=USD&g=z&c=DZD&c=ARS&c=AUD&c=ATS&c=BSD&c=BHD&c=BBD&c=BEF&c=BMD&c=BRL&c=GBP&c=BGL&c=CAD&c=CLP&c=CNY&c=COP&c=CYP&c=CZK&c=DKK&c=NLG&c=XCD&c=EGP&c=EUR&c=FJD&c=FIM&c=FRF&c=XAF&c=XPF&c=DEM&c=GHC&c=XAU&c=GRD&c=HNL&c=HKD&c=HUF&c=ISK&c=INR&c=IDR&c=IEP&c=ILS&c=ITL&c=JMD&c=JPY&c=JOD&c=KWD&c=LBP&c=LUF&c=MYR&c=MTL&c=MXN&c=MAD&c=NZD&c=NOK&c=PKR&c=PAB&c=PEN&c=PHP&c=XPT&c=PLN&c=PTE&c=ROL&c=RUR&c=SAR&c=XAG&c=SGD&c=SKK&c=SIT&c=ZAR&c=KRW&c=ESP&c=XDR&c=LKR&c=SDD&c=SEK&c=CHF&c=TWD&c=THB&c=TTD&c=TND&c=TRL&c=AED&c=VEB&c=ZMK"); //KIO will delete this
	postData.assign(args->latin1(),args->length());
	KIO::TransferJob *job = KIO::http_post( "http://fx.sauder.ubc.ca/cgi/fxdata", postData, false );
	job->addMetaData("content-type", "Content-Type: application/x-www-form-urlencoded" ); // This is a bit strange??
	transferData(job);
}  
int KExPacificMain::readData(QTextStream &t) {
	typedef QValueList<QDate> Dates;
	Dates dates;
	QString line,pair,target,base;
	int slash;
	bool ok;
	int row=1;
	int result=0;
  int maxcol=-1;
	addCurrency("USD");
	while ( !t.eof() ) {
	  line = t.readLine();
		if (row==2) {
			QStringList datelist=QStringList::split(TAB_CHAR,line,true);
			QStringList::ConstIterator it;
      for( it = datelist.begin(); it != datelist.end(); ++it ) {
        dates.append(KExDataEngine::parseDate(*it,'/'));
        maxcol++;
      }
		}
		if (row>2) {
			QStringList ratelist=QStringList::split(TAB_CHAR,line,true);
			QStringList::ConstIterator it=ratelist.begin();
			pair=*it;
			slash=pair.find('/');
			if (slash>0) {
        target=pair.left(slash).stripWhiteSpace();
				base=pair.right(pair.length()-slash-1).stripWhiteSpace();
				int i=maxcol;
      	for( it = ratelist.fromLast(); it != ratelist.begin(); --it ) {
					Rate r=(Rate)(*it).toDouble(&ok);
					if (ok && r>0) {
            //qDebug("ADD MAIN: (col:"+QString::number(i)+") "+target+"-"+base+"-"+QString::number(r)+"-"+dates[i].toString());
						if (addCurrency(target))
							addRate(target,base,r,dates[i],Reliable);
						result++;
						break;
					}
					i--;
				}
			}
		}
		row++;
  }
	return result;
}

