/***************************************************************************
                          kexpacificsupplementary.cpp  -  description
                             -------------------
    begin                : Tue Mar 18 2003
    copyright            : (C) 2003 by Tero Favorin
    email                : tero@favorin.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <klocale.h>
 
#include "kexpacificsupplementary.h"

KExPacificSupplementary::KExPacificSupplementary(const QString& name,KExDataSource *src) : KExDataRetriever(name,src) { 
}
KExPacificSupplementary::~KExPacificSupplementary(){
}
void KExPacificSupplementary::startTransfer() {
	KIO::TransferJob *job = KIO::get("http://fx.sauder.ubc.ca/supplement.html",true,false);
	transferData(job);
}
int KExPacificSupplementary::readData(QTextStream &t) {
	QString line,target,base;
      QString txt;
  QDate date;
	bool ok,inrate=false;
	int row=1, result=0, column=0;
	addCurrency("USD");
	addCurrency("CAD");
	addCurrency("EUR");
	addCurrency("GBP");
	while ( !t.eof() ) {
	  line = t.readLine();
    if (row==4) {
      line=getText(line);
      if (line.length()>41) {
        line=line.remove(0,41).stripWhiteSpace();
        KLocale loc=KLocale("en");
        loc.setDateFormat("%B %d, %Y");
        date=loc.readDate(line,&ok);
      }
    }
    if (line.contains("<tr") && !line.contains("Currency")) {
      inrate=true;
      column=0;
    }
    if (line.contains("</tr>") && inrate)
      inrate=false;
    if (inrate && line.contains("<td")) {
      if (column==1)
        target=getText(line).stripWhiteSpace();
      if (column==7) {
        Rate r=(Rate)getText(line).stripWhiteSpace().toDouble(&ok);
        if (ok && date.isValid()) {
          switch (column) {
            case 5: base="CAD"; break;
            case 7: base="USD"; break;
            case 9: base="EUR"; break;
            case 11: base="GBP"; break;
          }
          //qDebug("ADD SUPP: "+target+"-"+base+"-"+QString::number(r)+"-"+date.toString());
					if (addCurrency(target))
						addRate(target,base,r,date,Unreliable);
          result++;
        }        
      }
      column++;
    }
	  row++;
  }
	return result;
}

