/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Mon Mar  4 11:43:40 EET 2002
    copyright            : (C) 2002 by Tero Favorin
    email                : tero@favorin.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kapplication.h>
#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>

#include "kexchange.h"

static const char *description =
	I18N_NOOP("KExchange currency converter.");
	
int main(int argc, char *argv[])
{

	KAboutData aboutData( "kexchange", "KExchange",
		VERSION, description, KAboutData::License_GPL,
		"(c) 2002-2003, Tero Favorin", I18N_NOOP("KExchange is a currency converter for over 150 currencies\nusing up-to-date exchange rates from the Internet."), "http://www.favorin.com/projects/kexchange", "support@favorin.com");
	aboutData.addAuthor("Tero Favorin",0, "tero@favorin.com");
  aboutData.addCredit("Holger Klemm",I18N_NOOP("German translation"),"holger.klemm@multimedia4linux.de");
	KCmdLineArgs::init( argc, argv, &aboutData );

  KApplication app;
 
  if (app.isRestored())
  {
    RESTORE(KexchangeApp);
  }
  else 
  {
    new KexchangeApp();
	}

  return app.exec();
}  
